#!/usr/bin/python
# -*- coding:utf-8 -*-
import sys
import os
libdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'lib')
if os.path.exists(libdir):
    sys.path.append(libdir)
    
from TP_lib import gt1151
from TP_lib import epd2in13_V2
import time
import logging
import traceback
import threading
from pynput.keyboard import Key, Controller


logging.basicConfig(level=logging.DEBUG)
flag_t = 1
keyboard = Controller()

def pthread_irq() :
    print("pthread running")
    while flag_t == 1 :
        if(gt.digital_read(gt.INT) == 0) :
            GT_Dev.Touch = 1
        else :
            GT_Dev.Touch = 0
    print("thread:exit")


try:
    logging.info("epd2in13_V2 Touch Demo")
    
    epd = epd2in13_V2.EPD_2IN13_V2()
    gt = gt1151.GT1151()
    GT_Dev = gt1151.GT_Development()
    GT_Old = gt1151.GT_Development()
    
    logging.info("init and Clear")
    epd.init(epd.FULL_UPDATE)
    gt.GT_Init()
    #epd.Clear(0xFF)

    t = threading.Thread(target = pthread_irq)
    t.setDaemon(True)
    t.start()
    while(1):
        
        gt.GT_Scan(GT_Dev, GT_Old)
        if(GT_Old.X[0] == GT_Dev.X[0] and GT_Old.Y[0] == GT_Dev.Y[0] and GT_Old.S[0] == GT_Dev.S[0]):
            continue
        if(GT_Dev.X[0] > 100 and GT_Dev.X[0] <114 and GT_Dev.Y[0] > 2 and GT_Dev.Y[0] < 37):
            keyboard.type('1')
            print("1")
        if(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 38 and GT_Dev.Y[0] < 51):
            print("2")
            keyboard.type('2')

        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 52 and GT_Dev.Y[0] < 71):
            print("3")
            keyboard.type('3')
        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 73 and GT_Dev.Y[0] < 100):
            print("4")
            keyboard.type('4')
        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 101 and GT_Dev.Y[0] < 123):
            print("5")
            keyboard.type('5')
        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 125 and GT_Dev.Y[0] < 149):
            print("6")
            keyboard.type('6')
        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 150 and GT_Dev.Y[0] < 172):
            print("7")
            keyboard.type('7')
        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 175 and GT_Dev.Y[0] < 197):
            print("8")
            keyboard.type('8')
        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 199 and GT_Dev.Y[0] < 223):
            print("9")
            keyboard.type('9')
        elif(GT_Dev.X[0] > 100 and GT_Dev.X[0] < 114 and GT_Dev.Y[0] > 225 and GT_Dev.Y[0] < 248):
            print("0")
            keyboard.type('0')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 2 and GT_Dev.Y[0] < 37):
            print("Q")
            keyboard.type('Q')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 38 and GT_Dev.Y[0] < 51):
            print("W")
            keyboard.type('W')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 52 and GT_Dev.Y[0] < 71):
            print("E")
            keyboard.type('E')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 73 and GT_Dev.Y[0] < 100):
            print("R")
            keyboard.type('R')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 101 and GT_Dev.Y[0] < 123):
            print("T")
            keyboard.type('T')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 125 and GT_Dev.Y[0] < 149):
            print("Y")
            keyboard.type('Y')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 150 and GT_Dev.Y[0] < 172):
            print("U")
            keyboard.type('U')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 175 and GT_Dev.Y[0] < 197):
            print("I")
            keyboard.type('I')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 199 and GT_Dev.Y[0] < 223):
            print("O")
            keyboard.type('O')
        elif(GT_Dev.X[0] > 70 and GT_Dev.X[0] < 92 and GT_Dev.Y[0] > 225 and GT_Dev.Y[0] < 248):
            print("P")
            keyboard.type('P')

        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 23 and GT_Dev.Y[0] < 32):
            print("A")
            keyboard.type('A')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 35 and GT_Dev.Y[0] < 59):
            print("S")
            keyboard.type('S')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 61 and GT_Dev.Y[0] < 87):
            print("D")
            keyboard.type('D')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 90 and GT_Dev.Y[0] < 112):
            print("F")
            keyboard.type('F')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 115 and GT_Dev.Y[0] < 138):
            print("G")
            keyboard.type('G')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 140 and GT_Dev.Y[0] < 159):
            print("H")
            keyboard.type('H')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 153 and GT_Dev.Y[0] < 181):
            print("J")
            keyboard.type('J')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 190 and GT_Dev.Y[0] < 210):
            print("K")
            keyboard.type('K')
        elif(GT_Dev.X[0] > 53 and GT_Dev.X[0] < 61 and GT_Dev.Y[0] > 211 and GT_Dev.Y[0] < 236):
            print("L")
            keyboard.type('L')

        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 5 and GT_Dev.Y[0] < 12):
            print("Caps")
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 15 and GT_Dev.Y[0] < 44):
            print("z")
            keyboard.type('Z')
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 46 and GT_Dev.Y[0] < 74):
            print("X")
            keyboard.type('X')
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 75 and GT_Dev.Y[0] < 92):
            print("C")
            keyboard.type('C')
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 94 and GT_Dev.Y[0] < 115):
            print("V")
            keyboard.type('V')
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 119 and GT_Dev.Y[0] < 149):
            print("B")
            keyboard.type('B')
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 153 and GT_Dev.Y[0] < 181):
            print("N")
            keyboard.type('N')
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 190 and GT_Dev.Y[0] < 205):
            print("M")
            keyboard.type('M')
        elif(GT_Dev.X[0] > 22 and GT_Dev.X[0] < 31 and GT_Dev.Y[0] > 210 and GT_Dev.Y[0] < 248):
            print("DEL")
            keyboard.type('DEL')
                
            
        elif(GT_Dev.X[0] > 0 and GT_Dev.X[0] < 18 and GT_Dev.Y[0] > 0 and GT_Dev.Y[0] < 15):
            print("Menu")
        elif(GT_Dev.X[0] > 0 and GT_Dev.X[0] < 18 and GT_Dev.Y[0] > 17 and GT_Dev.Y[0] < 120):
            print("Space")
        elif(GT_Dev.X[0] > 0 and GT_Dev.X[0] < 18 and GT_Dev.Y[0] > 216 and GT_Dev.Y[0] < 246):
            print("Enyer")
         
            
                          
except IOError as e:
    logging.info(e)
    
except KeyboardInterrupt:    
    logging.info("ctrl + c:")
    flag_t = 0
    epd.sleep()
    time.sleep(2)
    t.join()
    epd.Dev_exit()
    exit()
